;;; -*- Mode: Lisp; Package: 2ch -*-
;;; 2ch-dialog.l --- 2ch-mode  dialog g Ascii Art ̕\^ҏW

;; Copyright (C) 2001-2005 OHKUBO Hiroshi <ohkubo@s53.xrea.com>

;; Author: OHKUBO Hiroshi <ohkubo@s53.xrea.com>
;; Time-stamp: <2005/10/08 16:16:30 +0900>

;;; Commentary:

;; Description:
;;
;;      񂪌JĂ 2ch-mode Ɏ AA p̃_CAO
;;      @\ǉ܂B
;;      炩̌` 2ch-mode Ɏ荞ł_ł̃t@C
;;      VSďł܂B
;;

;; Installation:
;;
;;      1. A[JCuWJ 2ch-dialog.l  $XYZZY/site-lisp 
;;         Rs[܂B
;;
;;      2. oCgRpC܂B
;;
;;              M-x byte-compile-file
;;              Byte compile file: $XYZZY/site-lisp/2ch-dialog.l
;;
;;      3. ~/.2ch/config.l Ɉȉ̃R[hǉ܂B
;;
;;              (require "2ch-dialog")
;;
;;      4. config.l oCgRpCĂꍇ́AoCgRpC
;;         ܂B
;;
;;      5. L̐ݒ𔽉f邽߂ɁAM-x 2ch Ďs܂B
;;

;; Uninstallation:
;;
;;      1. 2ch-dialog.l ɊւLq폜܂B
;;
;;      2. config.l oCgRpCĂꍇ́AoCgRpC
;;         ܂B
;;

;; Key bind:
;;
;;      [X]
;;              z               ̔ AA _CAOŕ\
;;              Z                AA _CAOŕ\i͈͂́j
;;
;;      [tH[]
;;              C-c z            2ch AA ␳ AA _CAOŕҏW
;;

;; Customize:
;;
;;      ~/.2ch/config.l 
;;
;;          (setq *dialog-width* 256)   ; <integer>
;;          (setq *dialog-height* 256)  ; <integer>
;;

;; Changes:
;;
;;      Sat, 08 Oct 2005 16:12:54 +0900
;;        E[AhXύXB
;;        ECZX(CBSDCZX)LځB
;;
;;      Sun, 13 Jun 2004 20:32:19 +0900
;;        ENetInstaller ΉB
;;
;;      Fri, 01 Mar 2002 19:18:43 +0900
;;        EWvftHg̔ԍB
;;
;;      Sat, 23 Feb 2002 00:49:48 +0900
;;        EÕXɈړ鏈CB
;;
;;      Mon, 18 Feb 2002 01:52:54 +0900
;;        E2ch Xɏ̂ɏȂĂ݂B
;;

;; Licence:
;;
;;    2ch-dialog ͏CBSDCZXɊÂėp\łB
;;    <http://www.opensource.org/licenses/bsd-license.php>
;;
;;
;;    Copyright (C) 2001-2005, OHKUBO Hiroshi.  All rights reserved.
;;
;;    Redistribution and use in source and binary forms, with or without
;;    modification, are permitted provided that the following conditions
;;    are met:
;;
;;    1. Redistributions of source code must retain the above copyright
;;       notice, this list of conditions and the following disclaimer.
;;
;;    2. Redistributions in binary form must reproduce the above copyright
;;       notice, this list of conditions and the following disclaimer in
;;       the documentation and/or other materials provided with the
;;       distribution.
;;
;;    3. Neither the name of the University nor the names of its
;;       contributors may be used to endorse or promote products derived
;;       from this software without specific prior written permission.
;;
;;    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
;;    ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;;    LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
;;    A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
;;    OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
;;    SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
;;    LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
;;    DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
;;    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
;;    (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
;;    OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
;;

;;; Code:

(provide "2ch-dialog")

(eval-when (:compile-toplevel :load-toplevel :execute)
  (require "2ch/macro"))
(require "2ch/thread")
(require "2ch/form")

(in-package "2ch")

(defvar *dialog-width* 256)
(defvar *dialog-height* 256)

(defvar *thread-view-current-dialog-move* :next)

(defun thread-view-current-dialog ()
  (interactive)
  (let ((article (thread-current-article)) next-article jump-number
        (max-article-number
         (save-excursion
           (goto-char (point-max))
           (thread-line-number (thread-current-article)))))
    (loop
      (unless (thread-line-number article)
        (return))
      (if (string-match ">>\\([0-9]+\\)" (thread-line-body article))
          (setq jump-number (parse-integer (match-string 1)))
        (setq jump-number (thread-line-number article)))
      (multiple-value-bind (result data)
          (dialog-box
           `(dialog 0 0 ,*dialog-width* ,*dialog-height*
                    (:caption
                     ,(format nil "~03D ~A <~A> ~A"
                              (thread-line-number article)
                              (thread-line-name article)
                              (thread-line-addr article)
                              (thread-line-date article)))
                    (:font 12 "lr oSVbN")
                    (:control
                     (:button IDOK "OK" #x50010001
                      ,(- *dialog-width* 40 2 40 1) ,(- *dialog-height* 14 3) 40 14)
                     (:button IDCANCEL "ݾ" #x50010000
                      ,(- *dialog-width* 40 1) ,(- *dialog-height* 14 3) 40 14)
                     (:button nil "" #x50000007
                      ,(- *dialog-width* 2 (* (+ 26 1) 5) 26 2 (* (+ 2 40) 2) 1)
                      ,(- *dialog-height* 22 1) ,(+ 2 (* (+ 26 1) 5) 26 2) 22)
                     (:button move-nil "(&F)" #x50000009
                      ,(- *dialog-width* (* (+ 26 1) 5) 26 2 (* (+ 2 40) 2) 1)
                      ,(- *dialog-height* 10 4) 26 10)
                     (:button move-next "(&N)" #x50000009
                      ,(- *dialog-width* (* (+ 26 1) 4) 26 2 (* (+ 2 40) 2) 1)
                      ,(- *dialog-height* 10 4) 26 10)
                     (:button move-previous "O(&P)" #x50000009
                      ,(- *dialog-width* (* (+ 26 1) 3) 26 2 (* (+ 2 40) 2) 1)
                      ,(- *dialog-height* 10 4) 26 10)
                     (:button move-jump "(&J)" #x50000009
                      ,(- *dialog-width* (* (+ 26 1) 2) 26 2 (* (+ 2 40) 2) 1)
                      ,(- *dialog-height* 10 4) 26 10)
                     (:edit move-jump-number nil #x50810086
                      ,(- *dialog-width* (* (+ 26 1) 1) 26 2 (* (+ 2 40) 2) 1)
                      ,(- *dialog-height* 14 3) 26 14)
                     (:spin move-jump-number-spin nil #x500000b6
                      ,(- *dialog-width* (* (+ 26 1) 1) 16 2 (* (+ 2 40) 2) 1)
                      ,(- *dialog-height* 14 3) 10 14)
                     (:button move-back "(&B)"
                      ,(if *thread-history* #x50000009 #x58000009)
                      ,(- *dialog-width* 26 2 (* (+ 2 40) 2) 1)
                      ,(- *dialog-height* 10 4) 26 10)
                     (:edit view nil #x50b110c4
                      1 1 ,(- *dialog-width* 2) ,(- *dialog-height* 1 1 19 1))
                     ))
           (list (cons (case *thread-view-current-dialog-move*
                         (:next 'move-next)
                         (:previous 'move-previous)
                         (t 'move-nil))
                       t)
                 (cons 'move-jump-number (format nil "~D" jump-number))
                 (cons 'view (substitute-string
                              (thread-line-body article) "\n" "\r\n")))
           `((move-jump-number-spin :min 1 :max ,max-article-number)
             (move-jump-number :min 1 :max ,max-article-number
                               :range-error ,(format nil "1 ȏ ~D ȉw肵Ă"
                                                     max-article-number)
                               :type integer :type-error "l͂Ă")
             (move-nil :disable (move-jump-number move-jump-number-spin))
             (move-next :disable (move-jump-number move-jump-number-spin))
             (move-previous :disable (move-jump-number move-jump-number-spin))
             (move-back :disable (move-jump-number move-jump-number-spin))
             (move-jump :enable (move-jump-number move-jump-number-spin)))
           )
        (while (read-char-no-hang *keyboard* nil nil nil))
        (when (eq result 'IDOK)
          (cond
           ((cdr (assoc 'move-nil data))
            (setq *thread-view-current-dialog-move* nil))
           ((cdr (assoc 'move-next data))
            (setq *thread-view-current-dialog-move* :next))
           ((cdr (assoc 'move-previous data))
            (setq *thread-view-current-dialog-move* :previous))))
        (if (eq result 'IDOK)
            (cond
             ((cdr (assoc 'move-jump data))
              (thread-history-push)
              (thread-goto-number (cdr (assoc 'move-jump-number data)))
              (setq next-article (thread-current-article)))
             ((cdr (assoc 'move-back data))
              (thread-history-back)
              (setq next-article (thread-current-article)))
             (*thread-view-current-dialog-move*
              (case *thread-view-current-dialog-move*
                (:next
                 (thread-next-article-obstinacy))
                (:previous
                 (thread-previous-article)
                 (setq next-article (thread-current-article))
                 (when (equal article next-article)
                   (thread-previous-article))))
              (setq next-article (thread-current-article)))
             (t (return)))
          (return))
        (if (or (not next-article) (equal article next-article))
            (return))
        (refresh-screen)
        (setq article next-article)
        ))))

(defun thread-view-range-dialog ()
  (interactive)
  (let* ((body "")
         articles)
    (multiple-value-bind (beg end)
        (thread-get-range)
      (when (and beg end)
        (setq articles (thread-get-articles beg end))
        (dolist (article articles)
          (setq body (concat body (thread-line-body article)))))
      (dialog-box
       `(dialog 0 0 ,*dialog-width* ,*dialog-height*
                (:caption ,(format nil "~03D - ~03D" beg end))
                (:font 12 "lr oSVbN")
                (:control
                 (:button IDOK "OK" #x50010001
                  ,(- *dialog-width* 40 2 40 1) ,(- *dialog-height* 14 1) 40 14)
                 (:button IDCANCEL "ݾ" #x50010000
                  ,(- *dialog-width* 40 1) ,(- *dialog-height* 14 1) 40 14)
                 (:edit view nil #x50b110c4
                  1 1 ,(- *dialog-width* 2) ,(- *dialog-height* 2 14 2))
                 ))
       (list (cons 'view (substitute-string body "\n" "\r\n")))
       nil))))

(defun form-edit-dialog ()
  (interactive "*")
  (save-excursion
    (goto-line 8)
    (goto-bol)
    (multiple-value-bind (result data)
        (dialog-box
         `(dialog 0 0 ,*dialog-width* ,*dialog-height*
                  (:caption "ҏW")
                  (:font 12 "lr oSVbN")
                  (:control
                   (:edit edit nil #x50b110c4
                    1 1 ,(- *dialog-width* 2) ,(- *dialog-height* 2 14 2))
                   (:button IDOK "OK" #x50010001
                    ,(- *dialog-width* 40 2 40 1) ,(- *dialog-height* 14 1) 40 14)
                   (:button IDCANCEL "ݾ" #x50010000
                    ,(- *dialog-width* 40 1) ,(- *dialog-height* 14 1) 40 14)
                   ))
         ;; 2ch dlɂ̂ƂĘA󔒂1ɂAs󔒂B
         (list (cons 'edit
                     (substitute-string
                      (substitute-string
                       (substitute-string
                        (buffer-substring (point) (point-max))
                        "\n" "\r\n") "  +" " ") "^ " "")))
         nil)
      (while (read-char-no-hang *keyboard* nil nil nil))
      (when (eq result 'IDOK)
        (delete-region (point) (point-max))
        (insert
         (substitute-string (cdr (assoc 'edit data)) "\r\n" "\n")))
      )))

(define-key *thread-map* #\z 'thread-view-current-dialog)
(define-key *thread-map* #\Z 'thread-view-range-dialog)
(define-key *form-map* '(#\C-c #\z) 'form-edit-dialog)

;;; 2ch-dialog.l ends here
